import { ResolveTree } from "graphql-parse-resolve-info";
import { Build, Scope } from "graphile-build";
import QueryBuilder from "../QueryBuilder";

type FieldContext<T> = any;
type FieldWithHooksFunction = any;

interface SqlFieldOptions<T> {
  hoistCursor?: boolean;
  withFieldContext?: <T>(context: FieldContext<T>) => void;
  withQueryBuilder?: (
    queryBuilder: QueryBuilder,
    args: { parsedResolveInfoFragment: ResolveTree }
  ) => void;
}

export default function sqlField<T>(
  build: Build,
  fieldWithHooks: FieldWithHooksFunction,
  fieldName: string,
  fieldSpec: T,
  fieldScope: Scope<T>,
  whereFrom?: false | sql,
  options?: SqlFieldOptions<T>
): T;
